// Author: Pete Kirkham
//
// quad store.
//
// test signals.

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <iostream>


#include "utils/threading.h"

class signal_test
{
public:
    signal_test ()
    {
    }
    
    void do_tock ()
    {
        for (size_t i (0); i < 10; ++i)
        {
            std::cout << "wait until data required" << std::endl;
            _data_required.wait_for();
            
            std::cout << "signal data available" << std::endl;
            _data_available.signal();
        }
    }
    
    void do_tick ()
    {
        for (size_t i (0); i < 10; ++i)
        {
            std::cout << "signal data required" << std::endl;
            _data_required.signal();

            std::cout << "wait until data available" << std::endl;
            _data_available.wait_for();
        }
    }

    
private:
    pthread_t       _leap_thread;
    condition       _data_required;
    condition       _data_available;
};

typedef signal_test C;
typedef void (C::*f_type)();

int main (int narg, char** argvp)
{
    signal_test test;
    
    thread tick_thread(thread::spawn(&test, &signal_test::do_tick));
    thread tock_thread(thread::spawn(&test, &signal_test::do_tock));
    tick_thread.join();
    tock_thread.join();
}
